﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.85
@EndOfDesignText@
#Region Shared Files
'#CustomBuildAction: folders ready, %WINDIR%\System32\Robocopy.exe,"..\..\Shared Files" "..\Files"
'Ctrl + click to sync files: ide://run?file=%WINDIR%\System32\Robocopy.exe&args=..\..\Shared+Files&args=..\Files&FilesSync=True
#End Region
Sub Class_Globals
	Private Root As B4XView
	Private xui As XUI
	Public Wutils As WordUtils
End Sub
Public Sub Initialize
	B4XPages.GetManager.LogEvents = True
End Sub
Private Sub B4XPage_Created (Root1 As B4XView)
	Root = Root1
	Root.LoadLayout("MainPage")
	xui.SetDataFolder("testenvironment79")
	Wutils.Initialize
	Dim docstring As String = set_word_table
	Dim Document As WordDocument = Wutils.CreateDocument
	Document.Append($"
	${docstring}
	"$)
	' all Word tables have no borders
	Dim tables As List = Document.XWPFDocument.RunMethod("getTables", Null)
	For Each table As JavaObject In tables
		Me.as(JavaObject).RunMethod("removeBorders", Array(table))
	Next
	Dim f As String = Document.SaveAs(xui.DefaultFolder, "example.docx", True)
'	Wait For (Wutils.PowerShellConvertToPdf(f, File.Combine(xui.DefaultFolder, "example.pdf"), True)) Complete (Success As Boolean)
	Wait For (Wutils.OpenWord(f)) Complete (Success As Boolean)
End Sub
Private Sub set_word_table As String
	Dim sb As StringBuilder
	sb.Initialize
	sb.Append($"[table Alignment=left rows=${1} cols=${2}]"$)
	sb.Append($"[row]"$)
	Dim imgdir As String = File.DirAssets
	Dim imgfile As String = "banff_national_park_canada_small.png"
	sb.Append($"[cell width=${200}][p alignment=center][img dir="${imgdir}" filename="${imgfile}" width=${200} height=${100} /][/p][/cell]"$)
	Dim text As String = "A text next to an image in a table." & CRLF & "The text can be on the left or on the right of the image." & CRLF & _
						 "And of course in the row above or below the image."
	sb.Append($"[cell][p alignment=left]${text}[/p][/cell]"$)
	sb.Append($"[/row]"$)
	sb.Append($"[/table]"$)
	Log(sb.ToString)
	Return sb.ToString
End Sub

#if java
import org.apache.poi.xwpf.usermodel.*;
import org.openxmlformats.schemas.wordprocessingml.x2006.main.*;
public static void removeBorders(XWPFTable table) {
    CTTblPr tblpro = table.getCTTbl().getTblPr();
    CTTblBorders borders = tblpro.addNewTblBorders();
    borders.addNewBottom().setVal(STBorder.NONE); 
    borders.addNewLeft().setVal(STBorder.NONE);
    borders.addNewRight().setVal(STBorder.NONE);
    borders.addNewTop().setVal(STBorder.NONE);
    //also inner borders
    borders.addNewInsideH().setVal(STBorder.NONE);
    borders.addNewInsideV().setVal(STBorder.NONE);
}
#End If
